/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#include "etherxd.h"

ehandler ehandler_list_add(ehandler list, ehandler item)
{
    log_debug(ZONE,"list_add(%s)",item->host);

    item->next = list;
    return item;
}

ehandler ehandler_list_isolate(ehandler list, ehandler item)
{
    ehandler curr;

    log_debug(ZONE,"list_isolate(%s)",item->host);

    if(list == item)
    {
        list = item->next;
    }else{
        for(curr = list; curr != NULL; curr = curr->next)
        {
            if(curr->next == item)
                break;
        }
        if(curr != NULL)
            curr->next = curr->next->next;
    }

    return list;
}

ehandler ehandler_list_free(ehandler list, ehandler item)
{
    log_debug(ZONE,"list_free(%s)",item->host);

    list = ehandler_list_isolate(list, item);
    pool_free(item->p);
    return list;
}

ehandler ehandler_list_get(ehandler list, char *host, char *namespace)
{
    ehandler curr;

    log_debug(ZONE,"list_get(%s)",host);

    for(curr = list; curr != NULL; curr = curr->next)
    {
        if(j_strcmp(curr->host, host) == 0 && j_strcmp(curr->namespace, namespace) == 0)
            return curr;
    }

    return NULL;
}

