/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#include <etherx.h>

/* creates new thread handle */
thread thread_new()
{
    pool p;
    thread t;

    p = pool_new();
    t = pmalloc(p,sizeof(_thread));
    t->p = p;
    t->data = NULL;

    return t;
}

/* gets the current thread's handle */
thread thread_get()
{
    pth_attr_t attr;
    thread *t;

    attr = pth_attr_of(pth_self());
    pth_attr_get(attr,PTH_ATTR_START_ARG,(void *)t);
    pth_attr_destroy(attr);

    return *t;
}

/* frees a thread handle */
void thread_free(thread t)
{
    pool_free(t->p);
}
